<?php

namespace App\Policies;

use App\Models\TopHeader;
use App\Models\User;
use Illuminate\Auth\Access\Response;

class TopHeaderPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->hasAnyPermission([
            'create topheader', 'edit topheader', 'view topheader', 'delete topheader'
        ]);
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, TopHeader $topHeader): bool
    {
        return $user->hasPermissionTo('view topheader');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasPermissionTo('create topheader');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, TopHeader $topHeader): bool
    {
        return $user->hasPermissionTo('edit topheader');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, TopHeader $topHeader): bool
    {
        return $user->hasPermissionTo('delete topheader');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, TopHeader $topHeader): bool
    {
        return $user->hasPermissionTo('restore topheader');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, TopHeader $topHeader): bool
    {
        return $user->hasPermissionTo('force delete topheader');
    }
}
